=== debian/changelog ===
ros-noetic-fuse-optimizers (0.4.2-1focal) focal; urgency=high

  * Adding roslint dependency to fuse_viz (#231 <https://github.com/locusrobotics/fuse/issues/231>)
    * Adding roslint dependency to fuse_viz
    * Silence CMP0048 warnings
  * Contributors: Tom Moore

 -- Stephen Williams <swilliams@locusrobotics.com>  Mon, 19 Jul 2021 23:00:00 -0000

ros-noetic-fuse-optimizers (0.4.1-1focal) focal; urgency=high

  * Improve logs on graph update exception thrown (#227 <https://github.com/locusrobotics/fuse/issues/227>)
    * Catch graph update exceptions and log fatal msg
    When the graph update method throws an exception the node crashes and
    there is no way to know what transaction caused the exception because we
    call notify after successfully updating the graph.
    This catches any exception thrown by the graph update method and logs a
    FATAL message that includes the current graph and the new transaction.
    * Add full stop to exception messages
    This homogenizes the exception messages from all exceptions thrown by
    the HashGraph class.
  * Fix diagnostics typo (#218 <https://github.com/locusrobotics/fuse/issues/218>)
  * Target frame optional (#217 <https://github.com/locusrobotics/fuse/issues/217>)
    * Make target_frame optional
    * Remove optional target_frame parameters in tests
  * Transform message in differential mode (#216 <https://github.com/locusrobotics/fuse/issues/216>)
    * Transform message in differential mode
    This is important because the relative transformation is not the same if
    the sensor and target frame are different.
    Consider for example the case of an IMU sensor upside down:
    * The robot base frame is base_link
    * The IMU sensor frame is imu_link
    * The imu_link transformation wrt base_link is 180 degrees wrt the y or
    x axis
    * The angular velocity around the z axis has opposite sign in the
    sensor frame wrt the target frame
    * Require pose_target_frame in differential mode
    * Roslint
    * Add pose_target_frame to optimizer test config
  * Check empty transaction with empty() method (#210 <https://github.com/locusrobotics/fuse/issues/210>)
  * Add solver summary info to diagnostics (#208 <https://github.com/locusrobotics/fuse/issues/208>)
    * Add solver summary info to diagnostics
    * Abort if optimization failed
  * Support throttling serialized graph publisher (#204 <https://github.com/locusrobotics/fuse/issues/204>)
    * Change sensor proc from gtest to gmock target
    * Move ThrottledCallback to fuse_core
    * Support generic callbacks in ThrottledCallback
    * Throttle graph publishing
    * Overload getPositiveParam for ros::Duration
    * Use getPositiveParam for ros::Duration parameters
  * Fix optimizer test config (#202 <https://github.com/locusrobotics/fuse/issues/202>)
    * Add dimensions to the sensor models, so we do not get these warnings:
    ``` bash
    [ WARN] [/Optimizer] [1604556511.895230377]: No dimensions were specified. Data from topic /imu will be ignored.
    [ WARN] [/Optimizer] [1604556511.899319309]: No dimensions were specified. Data from topic /pose will be ignored.
    [ WARN] [/Optimizer] [1604556511.905227451]: No dimensions were specified. Data from topic /odom will be ignored.
    ```
    * Add twist_target_frame to imu sensor model, so we do not get this
    error:
    ``` bash
    [FATAL] [/Optimizer] [1604557006.977288017]: Could not find required parameter twist_target_frame in namespace /Optimizer/imu
    ```
  * Purge transactions older than ignition max stamp (#183 <https://github.com/locusrobotics/fuse/issues/183>)
  * Fix roslint 0.12.0 (#186 <https://github.com/locusrobotics/fuse/issues/186>)
    * Fix roslint 0.12.0 include_what_you_use warnings
    Mostly for:
    * std::move -> #include <utility>
    * std::make_shared and similar -> #include <memory>
    * Remove static string variable not permitted by roslint 0.12.0, using a test fixture where needed.
  * Filter out transactions older than the lag window (#173 <https://github.com/locusrobotics/fuse/issues/173>)
    * Filter out transactions older than the lag window
    * Fix expiration time computation
    * Reset the lag expiration time when the smoother is reset
    * Reorganize class variables by their mutex guard
    * Add a mutex guard for start_time_; use start_time_ as a min time in the lag expiation computation
    * Add minStamp() and maxStamp() accessors to the Transaction class
    * Use the minStamp() and maxStamp() accessors to filter and purge transactions correctly
  * The started/ignited variables are accessed from multiple threads. (#172 <https://github.com/locusrobotics/fuse/issues/172>)
  * Replace ignition_sensors list param with ignition field (#163 <https://github.com/locusrobotics/fuse/issues/163>)
    * Remove ignition_sensors param and use a per-sensor ignition field
  * Get positive param API change (#169 <https://github.com/locusrobotics/fuse/issues/169>)
    * Change getPositiveParam API
    In order to match the getParam and getRequiredParam, so the value is
    not returned, but set in an in/out argument.
    * Move getPositiveParam and other param related functions to
    parameter.h from util.h, and updated the ros/unit tests accordingly.
    * Fix wrapAngle2D expected range to [-Pi, +Pi)
    Instead of (-Pi, +Pi], and update unit test to reflect that.
  * Add missed fuse_models dependencies (#164 <https://github.com/locusrobotics/fuse/issues/164>)
  * From a usage standpoint, the 'element' variable is getting modified and should not be const. The const was not causing compilation issues before because of some pointer indirection. (#160 <https://github.com/locusrobotics/fuse/issues/160>)
  * Added unit test to illustrate variable initialization bug (#158 <https://github.com/locusrobotics/fuse/issues/158>)
  * Fix Unicycle2DIgnition set_pose (#154 <https://github.com/locusrobotics/fuse/issues/154>)
    * Initialize StateHistoryElement::velocity_yaw

