=== debian/control ===
Source: ros-noetic-fuse-optimizers
Section: misc
Priority: optional
Maintainer: Stephen Williams <swilliams@locusrobotics.com>
Build-Depends: debhelper (>= 9.0.0), ros-noetic-catkin, ros-noetic-diagnostic-updater, ros-noetic-fuse-constraints, ros-noetic-fuse-core, ros-noetic-fuse-graphs, ros-noetic-fuse-models, ros-noetic-fuse-variables, ros-noetic-geometry-msgs, ros-noetic-nav-msgs, ros-noetic-pluginlib, ros-noetic-roscpp, ros-noetic-roslint, ros-noetic-rostest, ros-noetic-std-srvs
Homepage: 
Standards-Version: 3.9.2

Package: ros-noetic-fuse-optimizers
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-noetic-diagnostic-updater, ros-noetic-fuse-constraints, ros-noetic-fuse-core, ros-noetic-fuse-graphs, ros-noetic-fuse-variables, ros-noetic-pluginlib, ros-noetic-roscpp, ros-noetic-std-srvs
Description: The fuse_optimizers package provides a set of optimizer implementations.
 An optimizer is the object responsible for coordinating the sensors and motion model inputs, computing the optimal state values, and providing access to to the optimal state via the publishers.
